//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//+------------------------------------------------------------------
#property indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Orange
#property  indicator_width1  2
#property  indicator_level1  0

//
//
//
//
//

extern string TimeFrame          = "Current time frame";
extern int    MomPeriod          = 14;
extern int    MomPrice           = PRICE_CLOSE;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;
extern int    BarsPerSymbol      = 100;
extern string Symbols            = "EURUSD;GBPUSD;USDCHF";
extern string UniqueID           = "Multi pair momentum";
extern string _                  = "separator colors";
extern color  textColor          = Black;
extern color  backColor          = DarkGray;
extern color  zeroCrossUpColor   = LimeGreen;
extern color  zeroCrossDownColor = HotPink;
extern int    separatorWidth     = 6;

//
//
//
//
//

double value[];
double work[];
double trend[];

//
//
//
//
//

int      window;  
string   aPairs[];
string   shortName;
double   minValue;
double   maxValue;
double   maxValues[];
int      timeFrame;
bool     calculateValue;
string   indicatorFileName;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,value);
   SetIndexBuffer(1,work);
   SetIndexBuffer(2,trend);
      calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      indicatorFileName = WindowExpertName();

      //
      //
      //
      //
      //

      Symbols = StringTrimLeft(StringTrimRight(Symbols));
      if (StringSubstr(Symbols,StringLen(Symbols),1) != ";")
                       Symbols = StringConcatenate(Symbols,";");

         //
         //
         //
         //
         //                                   
            
         int s =  0;
         int i =  StringFind(Symbols,";",s);
         while (i > 0)
         {
            string current = StringSubstr(Symbols,s,i-s);
            ArrayResize(aPairs,ArraySize(aPairs)+1);
                        aPairs[ArraySize(aPairs)-1] = current;
                        if (current == Symbol())
                        {
                           string temp      = aPairs[0];
                                  aPairs[0] = current;
                                  aPairs[ArraySize(aPairs)-1] = temp;
                        }                                       
            s = i + 1;
            i = StringFind(Symbols,";",s);
         }
         ArrayResize(maxValues,ArraySize(aPairs));

      //
      //
      //
      //
      //
 
      separatorWidth = MathMax(separatorWidth,4);
      shortName      = UniqueID;
      timeFrame      = stringToTimeFrame(TimeFrame);
   IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   for (int i = 0; i < ArraySize(aPairs); i++)
   { 
         ObjectDelete(shortName+i);
         ObjectDelete(shortName+i+i);
   }         
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   if (calculateValue) { calculateIndicator(); return(0); }
   int    i,k,limit = ArraySize(aPairs);
   double max;
   
   //
   //
   //
   //
   //

   window = WindowFind(shortName);  
   ArrayInitialize(maxValues,0);
         minValue = 0;
         maxValue = 0;
                for(i=0,k=0; i<limit; i++) calculateValues(aPairs[i],BarsPerSymbol,k,i);
                for(i=0;     i<limit; i++) if (max < maxValues[i]) max = maxValues[i];
                for(i=0,k=0; i<limit; i++) plotGraph(aPairs[i],BarsPerSymbol,k,i,max);
   for (i=0;i<indicator_buffers;i++) SetIndexDrawBegin(i,Bars-k);
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void plotGraph(string symbol,int limit, int& shift,int element, double max)
{
   for(int i=limit; i>=0; i--)
      value[i+shift]   = work[i+shift];
   createLabel(symbol,element,shift+limit+separatorWidth-2,max,isSignalCrossing(shift));
   
   //
   //
   //
   //
   //
   
   shift += (limit+separatorWidth-1);
}

//
//
//
//
//

int isSignalCrossing(int shift)
{
   double res = (work[shift]*work[shift+1]); 
      if (res<=0)
         if (work[shift]>0) return( 1);
         else               return(-1);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void calculateIndicator()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return;
      if(counted_bars>0) counted_bars--;
           int limit=MathMax(Bars-counted_bars,Bars-1);
           
   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      value[i] = iMA(NULL,0,1,0,MODE_SMA,MomPrice,i)-iMA(NULL,0,1,0,MODE_SMA,MomPrice,i+MomPeriod);
      trend[i] = trend[i+1];
         if (value[i]>0) trend[i] =  1;
         if (value[i]<0) trend[i] = -1;
   }
   manageAlerts();
}

//
//
//
//
//

void calculateValues(string symbol,int limit,int& shift,int element)
{
   for(int i=0; i<limit; i++)
   {
      int y=iBarShift(NULL,timeFrame,Time[i]);
         work[i+shift]  = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",MomPeriod,MomPrice,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
         trend[i+shift] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",MomPeriod,MomPrice,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,2,y);
          
      maxValues[element] = MathMax(MathAbs(work[i+shift]),maxValues[element]);
      maxValue           = MathMax(work[i+shift],maxValue);
      minValue           = MathMin(work[i+shift],minValue);
   }            

   //
   //
   //
   //
   //

   for (i=0;i<separatorWidth;i++) {
         value[shift+limit+i]   = EMPTY_VALUE;
         work[shift+limit+i]    = EMPTY_VALUE;
      }         
   shift += (limit+separatorWidth-1);
   return;
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void createLabel(string symbol,int element, int shift, double max, int signalCrossing)
{
   string name = shortName+element;
   double price1 = maxValue;
   double price2 = minValue;
   
   //
   //
   //
   //
   //
   
   if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_TEXT,window,0,0);
            ObjectSet(name,OBJPROP_ANGLE,90);
            ObjectSetText(name,symbol,10,"Arial bold");
      }
      ObjectSet(name,OBJPROP_TIME1 ,Time[shift]);
      ObjectSet(name,OBJPROP_PRICE1,(price1+price2)/2);
      ObjectSet(name,OBJPROP_COLOR,textColor);

   //
   //
   //
   //
   //

   name = shortName+element+element;
   if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_RECTANGLE,window,0,0,0,0);
            ObjectSet(name,OBJPROP_COLOR,backColor);
      }         
      ObjectSet(name,OBJPROP_TIME1,Time[shift]);
      ObjectSet(name,OBJPROP_PRICE1,price1);
      ObjectSet(name,OBJPROP_TIME2,Time[shift-(separatorWidth-2)]);
      ObjectSet(name,OBJPROP_PRICE2,price2);
      if (signalCrossing!=0)
           if (signalCrossing>0)
                  ObjectSet(name,OBJPROP_COLOR,zeroCrossUpColor);
           else   ObjectSet(name,OBJPROP_COLOR,zeroCrossDownColor);
      else ObjectSet(name,OBJPROP_COLOR,backColor);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
            
      if (trend[whichBar]!= trend[whichBar+1])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (trend[whichBar] ==  1) doAlert(time1,mess1," momentum crossed zero line up");
            if (trend[whichBar] == -1) doAlert(time1,mess1," momentum crossed zero line down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" momentum",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}